glibmm 2.4: Gio::Cancellable Class Reference

Main Page Widgets glibmm Namespaces Book

# Gio::Cancellable Class Reference

Allows actions to be cancelled. More...

Inheritance diagram for Gio::Cancellable:

[legend]

List of all members.

## Public Member Functions
virtual | ~Cancellable ()
GCancellable* | gobj ()
| Provides access to the underlying C GObject.
const GCancellable* | gobj () const
| Provides access to the underlying C GObject.
GCancellable* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | is_cancelled () const
| Checks if a cancellable job has been cancelled.
int | get_fd () const
| Gets the file descriptor for a cancellable job.
void | cancel ()
| Will set cancellable to cancelled, and will emit the CANCELLED signal.
void | push_current ()
| Pushes cancellable onto the cancellable stack.
void | pop_current ()
| Pops cancellable off the cancellable stack (verifying that cancellable is on the top of the stack).
void | reset ()
| Resets cancellable to its uncancelled state.
Glib::SignalProxy0<void> | signal_cancelled ()
## Static Public Member Functions
static Glib::RefPtr<Cancellable> | create ()
static Glib::RefPtr<Cancellable> | get_current ()
| Gets the top cancellable from the stack.
## Protected Member Functions
| Cancellable ()
virtual void | on_cancelled ()
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr<Gio::Cancellable> | wrap (GCancellable* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Allows actions to be cancelled.

Cancellable is a thread-safe operation cancellation stack used throughout GIO to allow for cancellation of synchronous and asynchronous operations.

Since glibmm 2.16:

## Constructor & Destructor Documentation

virtual Gio::Cancellable::~Cancellable | ( |  | ) | `[virtual]`

Gio::Cancellable::Cancellable | ( |  | ) | `[protected]`

## Member Function Documentation

GCancellable* Gio::Cancellable::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

const GCancellable* Gio::Cancellable::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GCancellable* Gio::Cancellable::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

static Glib::RefPtr<Cancellable> Gio::Cancellable::create | ( |  | ) | `[static]`

bool Gio::Cancellable::is_cancelled | ( |  | ) | const

Checks if a cancellable job has been cancelled.

Returns:
  `true` if cancellable is cancelled, `false` if called with `0` or if item is not cancelled.

int Gio::Cancellable::get_fd | ( |  | ) | const

Gets the file descriptor for a cancellable job.

This can be used to implement cancellable operations on Unix systems. The returned fd will turn readable when cancellable is cancelled.

Returns:
  A valid file descriptor. -1 if the file descriptor is not supported, or on errors.

void Gio::Cancellable::cancel | ( |  | ) |

Will set cancellable to cancelled, and will emit the CANCELLED signal.

This function is thread-safe. In other words, you can safely call it from another thread than the one running an operation that was passed the cancellable.

static Glib::RefPtr<Cancellable> Gio::Cancellable::get_current | ( |  | ) | `[static]`

Gets the top cancellable from the stack.

Returns:
  A Cancellable from the top of the stack, or `0` if the stack is empty.

void Gio::Cancellable::push_current | ( |  | ) |

Pushes cancellable onto the cancellable stack.

The current cancllable can then be recieved using g_cancellable_get_current().

This is useful when implementing cancellable operations in code that does not allow you to pass down the cancellable object.

This is typically called automatically by e.g. File operations, so you rarely have to call this yourself.

void Gio::Cancellable::pop_current | ( |  | ) |

Pops cancellable off the cancellable stack (verifying that cancellable is on the top of the stack).

void Gio::Cancellable::reset | ( |  | ) |

Resets cancellable to its uncancelled state.

Glib::SignalProxy0<void> Gio::Cancellable::signal_cancelled | ( |  | ) |

Prototype:
  `void on_my_cancelled()`

virtual void Gio::Cancellable::on_cancelled | ( |  | ) | `[protected, virtual]`

## Friends And Related Function Documentation

Glib::RefPtr<Gio::Cancellable> wrap | ( | GCancellable * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- cancellable.h